Unit Topo;

INTERFACE

Uses dos,crt,graph;

TYPE
    BUTTON_ST = (REL,LEFT,RIGHT,LR,MIDDLE,LM,RM,ALL);
    BITMAP = array [1..31] of word;

Const
     BREAK:boolean=false;


Procedure MOUSEEXIT;
Procedure RESET_MOUSE(VAR result,ntasti:word);
Procedure SHOW_CURSOR;
procedure HIDE_CURSOR;
procedure READ_MOUSE(VAR butt:byte; VAR col,row:word);
procedure SET_CURSOR_POS(col,row:word);
Procedure DEFINE_XRANGE(Xmin,Xmax:word);
procedure DEFINE_YRANGE(Ymin,Ymax:word);
procedure GRAPH_CURSOR(VAR imm:BITMAP);
procedure PUSHBUTTON_CTRL(butt_id:word; VAR status:byte; VAR lastX,lastY,times:word);
procedure RELBUTTON_CTRL(butt_id:word; VAR status:byte; VAR lastX,lastY,times:word);

IMPLEMENTATION

VAR
   SaveExit:pointer;
   SYS_KBD:procedure;
   reg:registers;

CONST
     imm:BITMAP= ($FFFF,$8001,$8001,$8001,$8001,$8001,$8001,$8001,
                  $8001,$8001,$8001,$8001,$8001,$8001,$8001,$FFFF,
                  $1818,$1818,$1818,$1818,$1818,$1818,$1818,$1818,
                  $1818,$1818,$1818,$1818,$1818,$1818,$1818){,$1818);};

Procedure MouseExit;
 Begin
  ExitProc:=SaveExit;
  SetIntVec($9,@SYS_KBD);
 End;

Procedure ESC;interrupt;
 Begin
  if Port[$60] = 1 then
      BREAK:=true;
  asm PUSHF end;
  SYS_KBD;
 End;

Procedure RESET_MOUSE(VAR result,ntasti:word);
 Begin
  reg.AX:=0;
  INTR($33,reg);
  result:=reg.AX;
  ntasti:=reg.BX;
 End;

Procedure SHOW_CURSOR;assembler;
 asm
  mov AX,1
  INT $33
 end;

Procedure HIDE_CURSOR;assembler;
 asm
  mov AX,2
  INT $33
 end;

Procedure READ_MOUSE(VAR butt:byte; VAR col,row:word);
 begin
  with reg do
   begin
    AX:=3;
    INTR($33,reg);
    butt:=BL;
    col:=CX;
    row:=DX;
   End;
 end;

Procedure SET_CURSOR_POS(col,row:word);assembler;
 asm
  mov AX,4
  mov CX,col
  mov DX,row
  INT $33
 end;

Procedure DEFINE_XRANGE(Xmin,Xmax:word);assembler;
 asm
  mov AX,7
  mov CX,Xmin
  mov DX,Xmax
  INT $33
 End;

Procedure DEFINE_YRANGE(Ymin,Ymax:word);assembler;
 asm
  mov AX,8
  mov CX,Ymin
  mov DX,Ymax
  INT $33
 End;

Procedure GRAPH_CURSOR(VAR imm:bitmap);
 Begin
  with reg do
   begin
    AX:=9;
    BX:=8;
    CX:=8;
    DS:=Seg(imm);
    DX:=Ofs(imm);
   end;
  INTR($33,reg);
 end;

Procedure PUSHBUTTON_CTRL(butt_id:word; VAR status:byte; VAR lastX,lastY,times:word);
 Begin
  with reg do
   begin
    AX:=5;
    BX:=butt_id;
    INTR($33,reg);
    status:=AX;
    times:=BX;
    lastX:=CX;
    lastY:=DX;
   end;
 end;

Procedure RELBUTTON_CTRL(butt_id:word; VAR status:byte; VAR lastX,lastY,times:word);
 begin
  with reg do
   begin
    AX:=6;
    BX:=butt_id;
    INTR($33,reg);
    status:=AL;
    times:=BX;
    lastX:=CX;
    lastY:=DX;
   end;
 end;


begin
  asm CLI end;
    SaveExit:=ExitProc;
    GetIntVec($9,@SYS_KBD);
    SetIntVec($9,@ESC);
    ExitProc:=@MouseExit;
  asm STI end;
end.



